﻿"use strict";

var log = require('../util/log');
var mysql_im = require("../repository/mysql_im");

function login(user_id, token, client_id, platform, handler) {
    mysql_im.execQuery({
        "sql": "INSERT INTO user (user_id,token,client_id,platform,is_online,status) VALUES (?,?,?,?,1,1) ON DUPLICATE KEY UPDATE token=?,client_id=?,platform=?,is_online=1,status=1",
        "args": [user_id, token, client_id, platform, token, client_id, platform],
        "handler": handler
    });
}

function logout(user_id, handler) {
    mysql_im.execQuery({
        "sql": "UPDATE user SET is_online='0',status='0' WHERE user_id=?",
        "args": [user_id],
        "handler": handler
    });
}

function getUserbyID(user_id, handler) {
    mysql_im.execQuery({
        "sql": "SELECT platform,token,client_id,is_online,status from user WHERE user_id = ?",
        "args": [user_id],
        "handler": handler
    });
}

function deleteToken(token, handler) {
    mysql_im.execQuery({
        "sql": "DELETE FROM user WHERE token=?",
        "args": [token],
        "handler": handler
    });
}

function updateStatus(user_id, status, handler) {
    mysql_im.execQuery({
        "sql": "UPDATE user SET status=? WHERE user_id=?",
        "args": [status, user_id],
        "handler": handler
    });
}

exports.login = login;
exports.logout = logout;
exports.getUserbyID = getUserbyID;
exports.deleteToken = deleteToken;
exports.updateStatus = updateStatus;
