# 医生端IM服务器

此项目是医生端即时消息服务器，与患者端不同。患者端的即时消息服务器使用C++编写，并且不具有消息存储功能，医生端与患者端已经连通，参见im.patient项目的说明。以后可能使用node.js框架统一二者。

## 代码管理、开发与部署

### 代码管理

项目代码使用git管理，请安装git客户端并fork代码再下载修改。

### 开发环境安装

- 开发工具: node.js的代码可以使用文本编辑器开发，如：Sublime, vi, vim等。也可以使用IDE开发，推荐使用WebStorm，包含大量便捷功能，加速开发。
- 数据库准备: IM服务器使用MySQL数据库，因此需要先安装MySQL数据库。然后执行resources/schema/im_schema.sql与resources/schema/talk_group_schema.sql脚本文件，创建数据模式。
  第一个创建消息存储所需要的模式，第二个创建业务讨论组数据模式，并包含演示数据。

### 部署

为保证服务正常运行，当服务异常退出时自动重启服务，IM服务器使用appArmour脚本，对进程添加保护：进程异常退出时，自动重启。
为实现此目标，部署时通过appArmour启动服务即可实现进程的守护功能。

## 工程结构

- 消息流: 首先要明白即时消息的流程，有助于理解整个过程。医生端的IM仅关注医生部分，即下图中蓝色标注的内容。

![IM活动图](./doc/images/activity.png)

## 消息格式

https://my.oschina.net/antianlu/blog/190191

## 开发SDK

- 环境要求: IM提供了开发SDK，一个JS脚本。客户端可以通过引用此脚本或将此脚本打包到资源中。此外，脚本使用jQuery作为基础环境，因此客户端需要预先引用jQuery脚本。

- 开发流程: 通过以下链接引用SDK文件

    <script src='http://host:port/sdk/im.client.js'></script>
    
  SDK中封装了常用接口。